package com.kawanansemut.demoangular

import com.kawanansemut.demoangular.entities.User
import com.kawanansemut.demoangular.entities.UserRepository
import org.springframework.boot.autoconfigure.SpringBootApplication
import org.springframework.boot.context.event.ApplicationReadyEvent
import org.springframework.boot.runApplication
import org.springframework.context.annotation.Configuration
import org.springframework.context.event.EventListener
import org.springframework.stereotype.Component
import org.springframework.web.servlet.config.annotation.CorsRegistry
import org.springframework.web.servlet.config.annotation.WebMvcConfigurer

@SpringBootApplication
class DemoAngularApplication

fun main(args: Array<String>) {
	runApplication<DemoAngularApplication>(*args)
}


@Component
class justAfterStart(
		val userRepository: UserRepository
) {

	@EventListener(ApplicationReadyEvent::class)
	fun init() {
		userRepository.save(User("admin","admin","adminname"))
		userRepository.save(User("asmen","asmen","septiyan"))
		userRepository.save(User("spa","spa","tanto"))
	}


}

@Configuration
class MvcConfig : WebMvcConfigurer {

	override fun addCorsMappings(registry: CorsRegistry) {
		registry.addMapping("/**").allowedMethods("GET", "POST", "PUT", "DELETE").allowedOrigins("*")
				.allowedHeaders("*")
	}
}